/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* Programm zum Testen von "vollsteckbaren" 4 Mbyte      */
/* Speichererweiterungen fuer ATARI ST                   */
/* Stephan Litsch, 27.04.92                              */
/* Uebertragung auf OS-9 durch Rolf Hemmerling, 27.04.92 */
/*                                                       */
/* Fuer ANSI-C Compiler. Wenn das Schluesselwort         */
/* "volatile" vom (K&R oder Pseudo-ANSI) C-Compiler      */
/* wie MICROWARE-C (MWARE) nicht verarbeitet wird bzw.   */
/* die Verwendung von Registervariablen nicht abgewuergt */
/* werden kann, dann ist dieses Programm grober Unfug.   */
/* Dann werden u.U. nur Registeroperationen              */
/* durchgefuehrt.                                        */ 
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/* Betriebssystem waehlen */

#ifndef TOS
#undef TOS
#endif

#ifndef OS9
#define OS9
#endif

/* Compiler waehlen */

#ifndef PUREC
#undef PUREC
#endif

#ifndef MWARE
#define MWARE
#endif

/* Fuer OS-9 Speicherverwaltung waehlen */

#ifdef OS9
/* malloc: "begrenzter" Stack-Speicher, ziemlich sinnlose Programmversion */
/* #define MALLOC1(x) malloc(x) */
/* ebrk: "unbegrenzter" Hauptspeicher */
#define MALLOC2(x) ebrk(x)
#endif

/* Ende der Programm-Parameter */

#ifdef PUREC
#ifndef ANSI
#define ANSI
#endif
#endif

#ifdef MWARE
#ifdef ANSI
#undef ANSI
#endif
#endif

#ifdef ANSI
#include <STDLIB.H>
#endif

#ifdef MWARE
#define void unsigned short
#define volatile
#define K10000UL 0x10000L
#define K1000UL 0x1000L
#endif

#ifdef PUREC
#define K10000UL 0x10000UL
#define K1000UL 0x1000UL
#endif

#ifdef TOS
#define MALLOC(x) malloc(x)
#endif

#include <STDIO.H>

#ifdef TOS
#include "TOS.H"
#endif

/**********/
/*  main  */
/**********/

#ifdef ANSI
void main(void)
#else
void main()
#endif
{
				short  			  loop;
				long  			  count;
				long  			  length;
				void  			  *start;
				int               status;          
            	volatile unsigned short  *ptr;
            	long              errors = 0;	

	printf( "Viel Spass mit dem Memory-Tester !!!          \n" ) ;				
	printf( "Das Ding pollt 4096x ohne Pause auf jedem     \n" ) ;				
	printf( "Speicherwort rum. Matschige RAM's machen dabei\n" ) ;				
	printf( "meiner Erfahrung nach schnell dicke Backen.   \n" ) ;				
	printf( "Bei 4MB kann das allerdings schon ein paar    \n" ) ;				
	printf( "Stunden dauern.                               \n" ) ;				
	printf( "                        Stephan               \n" ) ;				
	printf( "                                              \n" ) ;				
    				
#ifdef TOS
    length = (long)MALLOC( -1L );
    if ((length != -1) && (length != 0))
     {
  	   start  = MALLOC( length );
  	 };
#endif
#ifdef OS9
#ifdef MALLOC1
    length = (long)MALLOC1( -1L );
    if ((length != -1) && (length != 0))
     {
  	   start  = (void *)MALLOC1( length );
  	 };
#endif
#ifdef MALLOC2
    printf("Number of 1K blocks to test (decimal value) ? \n");
    scanf("%d",&length);
    length = length * 1024L;
    start  = (void *)MALLOC2( length );
#endif
#endif
    if (((long)start != -1L) && ((long)start != 0L) && (length != 0L))
     {
	   printf( "Testing %ld bytes of memory\n", length ) ;

	   printf( "\nTesting %08lX ", start ) ;
	
	   for ( ptr=start, count = length/2 ; count-- ; ++ptr )
	    {
	   	  if ( (long)ptr % K10000UL == 0 )
		 	 printf( "\nTesting %08lX ", ptr ) ;
		  else
			if ( (long)ptr % K1000UL == 0 )
				printf( "." ) ;

		    *ptr = 0x0001 ;
		
		    for ( loop=0 ; loop<128 ; ++loop )		
		     {
		  	   /* Dies sind die **kritischen** Routinen,
			      Der Code muss einen Speicherzugriff 
			      nach dem anderen ohne was dazwischen 
			      durchfuehren */
			   
  			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
			*ptr <<= 1 ;
				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
			*ptr >>= 1 ;				
		   }
		
  		  if ( *ptr != 0x0001 )
		   {
		  	  printf( "\nDefect detected at position %lX\n", ptr ) ;
			  ++errors ;
		   }
	   }
	
	  printf( "\n%ld error(s) detected\n", errors ) ;
	  status = 0;
     }
    else
     {
	  printf( "\nNo memory allocated (%ld)\n", length) ;
	  status = 0;
     };
   exit(status) ;
#ifndef ANSI
   return(status);
#endif
}

