/**************************************/
/*              FillUp                */
/*       fill up file with data       */
/*------------------------------------*/
/*     (c) 1992 by Lukas Zeller       */
/**************************************/


/* Edition History
   ---------------
   001 : 92-03-18 : (full moon) created
*/

#include <stdio.h>
#include <ctype.h>
#include <modes.h>

extern int errno;

/* global variables */
/* ---------------- */

int nargc;  /* number of non-option (and non argv[0]) arguments  */

int num=0;
unsigned char databyte=0xFF;

/* main program */
main (argc,argv)

int argc;
char *argv[];

{
   int k,sz;
   char **argp, *dstfile;

   int dstpath;

   /* --- entry point */
   options(argc,argv);
   if (nargc!=1) {
      usage(argv[0]);
      exit (_errmsg(1,"one arguments argument required\n"));
   }
   argp=&argv[1];
   while (*(dstfile=*(argp++))=='-'); /* get next non-option argument */

   if((dstpath=open(dstfile,S_IWRITE+S_IREAD))<0)
      exit(_errmsg(errno,"Can't open file '%s' for append",dstfile));

   sz=_gs_size(dstpath);
   if (sz>=num) exit(_errmsg(0,"File is longer than %d --> no fill up\n",num));
   lseek(dstpath,sz,0);
   for (k=num-sz; k>0; k--) write(dstpath,&databyte,1);
   close(dstpath);
   printf("%d bytes (value=%d) appended: total file size is now %d\n",
          num-sz,databyte,num);
} /* main */


/**** display program usage */
usage (pname)
char *pname;
{
  printf("Syntax:   %s [<options>] <file>\n",pname);
  printf("Function: fill up file with constant data\n");
  printf("Options:  -?        : displays this text\n");
  printf("          -n=<num>  : append data until file is <num> bytes long\n");
  printf("          -i=<data> : fill data byte, default=255\n");
  printf("(c) 1992 by L.Zeller\n");
} /* usage */


/**** analyze command line options */
options (argc,argv)
int argc;
char *argv[];
{
  int count, nextarg;
  char *sc;

  for (count=nargc=0;++count<argc;) {
    if (*(sc=argv[count])=='-') {
      /* this argument is an option (begins with a hyphen) */
      nextarg=0;
      while ((*(++sc)!=NULL)&&!nextarg) {
        switch (tolower(*sc)) {
          case '?' : usage(argv[0]); exit(0);
          case 'n' : if (*(++sc)!='=') exit(_errmsg(1,"missing '=' for n option\n"));
                     num=atoi(++sc);
                     nextarg=1;
                     break;
          case 'i' : if (*(++sc)!='=') exit(_errmsg(1,"missing '=' for i option\n"));
                     databyte=(unsigned char) atoi(++sc);
                     nextarg=1;
                     break;
          default  : usage(argv[0]); exit(_errmsg(1,"unknown option '%c'\n",*sc));
          /* options with arguments may set nextarg to stop processing
             of this argument. Otherwise, *sc must be the last char processed */
        } /* switch */
      } /* while */
    } /* if hyphen */
    else nargc++;
  } /* for */
} /* options */

