/***   parser.c   ***/

#include <stdio.h>
#include <strings.h>
#include <math.h>
#include "header.h"

/* Parser */
parse(op) 
FILE *op;
{
   char *strcpy();
   int len,match,i;
   char line[MAXCHAR];
   char name[MAXCHAR],value[MAXCHAR];
   char word[100][MAXCHAR];
   char *keywords[MAXKEY];

   initkeywords(keywords);

   while (len=getline(op,line,MAXCHAR) > 0)
      if (getwords(line,len,word) >= 2) {
         strcpy(name,word[0]);
         strcpy(value,word[1]);
         match = NO;
         i = 0;
         while (i < MAXKEY && match==NO ) {
            if (strcmp(keywords[i],name) == 0) {
               match = YES;
               assignvalue(i,value);
               }
            i++;
            }
         if (match==NO) fprintf(stderr,"%s: Unknown keyword\n",name);
         }
}

/* Initialize the keywords */
initkeywords(keywords) 
char *keywords[];
{
   keywords[0] = "xlabel";
   keywords[1] = "ylabel";
   keywords[2] = "toplabel";
   keywords[3] = "grid";
   keywords[4] = "equalscale";
   keywords[5] = "postscript";
   keywords[6] = "printplot";
   keywords[7] = "line";
   keywords[8] = "linechange";
   keywords[9] = "marker";
   keywords[10]= "markerchange";
   keywords[11]= "scale";
   keywords[12]= "xticks";
   keywords[13]= "yticks";
   keywords[14]= "zticks";
   keywords[15]= "zlabel";
   keywords[16]= "hiddenline";
   keywords[17]= "nosort";
   keywords[18]= "printer";
   keywords[19]= "noplot";
}

/* Assign a value to a keyword */
assignvalue(index,value) 
int index;
char *value;
{
   char   *strcpy();
   char   *sprintf();
   extern char xlabel[MAXCHAR],ylabel[MAXCHAR],zlabel[MAXCHAR];
   extern char toplabel[MAXCHAR];
   extern char printer[MAXCHAR];
   extern int grid,equalscale,postscript,printplot,noplot;
   extern int line,linechange,marker,markerchange;
   extern int linetype[MAXTYPE], markertype[MAXTYPE];
   extern int hiddenline,nosort;
   extern int xticks,yticks,zticks;
   extern double scale;
   int i;

   double atof();

   switch (index) {
   case 0 : strcpy(xlabel , value); 
            fprintf(stdout,"   Options : Xlabel          = %s\n",xlabel);
            break;
   case 1 : strcpy(ylabel , value);
            fprintf(stdout,"   Options : Ylabel          = %s\n",ylabel);
            break;
   case 2 : strcpy(toplabel , value); 
            fprintf(stdout,"   Options : Top label       = %s\n",toplabel);
            break;
   case 3 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               grid = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  grid = OFF;
               fprintf(stdout,"   Options : grid            = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 4 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               equalscale = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  equalscale = OFF;
               fprintf(stdout,"   Options : equalscale      = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 5 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               postscript = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  postscript = OFF;
               fprintf(stdout,"   Options : postscript      = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 6 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               printplot  = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  printplot  = OFF;
               fprintf(stdout,"   Options : printplot       = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 7 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               line = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  line = OFF;
               fprintf(stdout,"   Options : line            = %s\n",value);
               if (line == OFF) marker = ON;
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 8 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               linechange = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  linechange = OFF;
               fprintf(stdout,"   Options : linechange      = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 9 : if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               marker = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  marker = OFF;
               fprintf(stdout,"   Options : marker          = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 10: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               markerchange = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  markerchange = OFF;
               fprintf(stdout,"   Options : markerchange    = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 11: scale = atof(value); 
            if (scale < 0.1 || scale > 1) scale = 1.0;
            fprintf(stdout,"   Options : scale           = %f\n",scale);
            break;
   case 12: xticks = atoi(value); 
            if (xticks <= 0 || xticks > 20) xticks = 4;
            fprintf(stdout,"   Options : xticks          = %d\n",xticks);
            break;
   case 13: yticks = atoi(value); 
            if (yticks <= 0 || yticks > 20) yticks = 4;
            fprintf(stdout,"   Options : yticks          = %d\n",yticks);
            break;
   case 14: zticks = atoi(value); 
            if (zticks <= 0 || zticks > 20) zticks = 4;
            fprintf(stdout,"   Options : zticks          = %d\n",zticks);
            break;
   case 15: strcpy(zlabel , value);
            fprintf(stdout,"   Options : Zlabel          = %s\n",zlabel);
            break;
   case 16: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               hiddenline = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  hiddenline = OFF;
               fprintf(stdout,"   Options : hiddenline      = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 17: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               nosort = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  nosort = OFF;
               fprintf(stdout,"   Options : nosort          = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   case 18: sprintf(printer,"-P%s",value);
            fprintf(stdout,"   Commands: Printer         = %s\n",printer);
            break;
   case 19: if ((strcmp(value,"on")==0) || (strcmp(value,"off")==0) ||
                (strcmp(value,"ON")==0) || (strcmp(value,"OFF")==0)) {
               noplot = ON;
               if ((strcmp(value,"off")==0) || (strcmp(value,"OFF")==0))
                  noplot = OFF;
               fprintf(stdout,"   Options : noplot          = %s\n",value);
               }
            else
               fprintf(stdout,"   Options : Unknown keyword = %s\n",value);
            break;
   default: break;
   }
}

/* Convert a line of characters into numbers; Not in use */
convertline(value)
char *value;
{
   extern int linetype[MAXTYPE];
   int i,j;

   for (i=0; i<MAXTYPE && value[i]!='\0'; i++) 
      linetype[i] = chartoint(value[i]);
   for (j=i; j<MAXTYPE; j++)
      linetype[j] = linetype[j % i];
}

/* Convert a character into a number */
chartoint(ch)
char ch;
{ 
   int num;

   switch (ch) {
   case '0' : num = 0; break;
   case '1' : num = 1; break;
   case '2' : num = 2; break;
   case '3' : num = 3; break;
   case '4' : num = 4; break;
   case '5' : num = 5; break;
   case '6' : num = 6; break;
   case '7' : num = 7; break;
   case '8' : num = 8; break;
   case '9' : num = 9; break;
   default  : fprintf(stderr,"Warning : Nonnumeric character %c in string",ch);
              num = 0; break;
   }
   return(num);
}

/* get line into s */
getline(op,s,lim) 
FILE *op;
char s[];
int lim;
{
    int c,i,j;

    /* read the line until termination marks ';' or '#' */
    for (i=0; i<lim-1 && (c=getc(op))!=EOF && c!='\n'&&c!='#'&& c!=';' ; ++i) 
       s[i] = c;
    if (i==lim-1 || c==';' ||c=='#' || c=='\n') s[i++] = '\n'; 
    if (c==';'||c=='#')
       for (j=0; (c=getc(op))!=EOF && c!='\n'; ++j);
    s[i] = '\0';

    return(i);
}

/* Get the first 2 words in a line */
getwords(s,length,word) 
char s[];
int length;
char word[100][MAXCHAR];
{
   int i,nc,nw,inword,collectword;
   char c;

   nc = nw = 0;
   inword = NO;
   collectword = NO;

   if (length==1 && s[0] == '\n') return(nw);
   for (i=0; s[i] != '\0'; i++) {
      c = s[i];
      if (c == ' ' || c=='\n' || c == '\t' || c=='=') {
         if (inword == YES && (collectword==NO || c=='\n') ) {
            word[nw++][nc++] = '\0';
            inword = NO;
            nc = 0;
         } else if (collectword == YES)
            word[nw][nc++] = c;
      } else if (c == '\'' || c == '"') {
         if (collectword == NO) collectword = YES; 
         else {
            collectword = NO; 
            word[nw++][nc++] = '\0';
            inword = NO;
            nc = 0;
         }
      } else {
         word[nw][nc++] = c;
         if (inword == NO) inword = YES;
      }
   }
   return(nw);
}

/* Convert a word into a number */
/* Currently not in use - use the intrinsic function atof() */
float word_to_number(word)  
char word[];
{
  int i;
  int decimal_flag;
  int exponent_flag;
  int decimal_count;
  int new_term;
  float number,sign,exponent,exp_sign;

  sign = 1.;
  exp_sign = 1.;
  decimal_flag = OFF;
  exponent_flag = OFF;
  decimal_count = 0;
  number = 0.;
  exponent = 0.;

  for (i = 0; word[i] != '\0'; i++)
  {
    if (word[i] == '-' && exponent_flag == OFF)
      sign = -1.;
    else if (word[i] != '+')
    {
      if (word[i] == '.')
        decimal_flag = ON;
      else
      if (word[i] == 'e')
        exponent_flag = ON;
      else
      {
        new_term = word[i] - '0';
        if (exponent_flag)
        {
          if (word[i] == '-')
            exp_sign = -1.;
          else 
            exponent = exponent * 10. + (float) new_term;
        }
        else {
          number = number * 10. + (float) new_term;
          if (decimal_flag) 
            decimal_count++;
          }
      }
    }
  }
  for (; decimal_count > 0; decimal_count--)
    number /= 10.; 
  
  number = number * sign * pow((double)10.,(exp_sign * exponent));

  return number;
}

