# define ERR -1

# include <stdio.h>
# include <modes.h>
# include <strings.h>

char            help_txt[] =
"OS-9/68k supplementary command.\n\
Written by Carsten Emde; may be copied for non-commercial use.\n\
Syntax: trunc <path> <num>\n\
Function: reduce length of file <path> to <num>, where <num>\n\
          specifies the new file length in decimal or optionally\n\
          in hexadecimal when preceeded by '$' or '0x'.\n\
Options: none\n";

extern int      errno;

main(argc, argv)
  int             argc;
  char           *argv[];
{
  char            cntrl[4];
  int             i, inpath, newlen = ERR, oldlen;

  for (i = 1; i < argc; i++) {
    if (!strcmp(argv[i], "-?")) {
      puts(help_txt);
      exit(0);
    }
  }

  if (argc != 3) {
    fputs(stderr, help_txt);
    exit(_errmsg(1, "wrong number of parameters, program aborted.\n"));
  }

  strcpy(cntrl, "%?");
  if (argv[2][0] == '$' || !strncmp(argv[2], "0x", 2)) {
    cntrl[1] = 'x';
    argv[2] += (argv[2][0] == '$') ? 1 : 2;
  } else
    cntrl[1] = 'd';
  sscanf(argv[2], cntrl, &newlen);
  if (newlen < 0)
    exit(_errmsg(1, "bad new length specified, program aborted.\n"));

  if ((inpath = open(argv[1], S_IREAD + S_IWRITE)) == ERR)
    exit(_errmsg(errno, "can't open '%s' due to ", argv[1]));

  oldlen = _gs_size(inpath);
  if (oldlen == ERR)
    exit(_errmsg(errno, "can't determine length of input file due to "));

  if (newlen >= oldlen)
    exit(_errmsg(1,
      "can't truncate since new file length (%1d) is not smaller than\n\
       old file length (%1d).\n", newlen, oldlen));
  if (_ss_size(inpath, newlen) == ERR)
    exit(_errmsg(errno, "can't set new file size due to "));
}
